      integer function debut(epais,ep1,ep2,transv,
     &ttrv,nm,p,q,q1,q2,q3,q4,s0x,s0z,shx,shz,
     &bords0,constante)
*
*     Parametres
*
*          constante:    constant for integration of TT equations
*          epais         thickness of crystal
*          transv        steps along the exit surface
*          ttrv          Absorbtion factor along the exit surface
*          p, q          steps along so and sh
*          q1, q2        functions of q used in the R vector (see Takagi)
*          q3,q4         additional for asymetric case. Computed but
*                        not used
*          s0x,s0z
*          shx,shz       Coordinates of nodes in s0,sh axes
*          nm            number of nodes along a characteristics
*          bords0        intensity along s0 (exit surface)
*          ep1           base triangle de Borrmann de n a so
*          ep2           base triangle de Borrmann de n a sh
*
      include 'reseau.h'
      include 'debut_array.h'
*              real ttrv(ndim)
*              real q3(ndim),q4(ndim)
*              real s0x(0:ndim),s0z(0:ndim),shx(0:ndim)
*              real shz(0:ndim)
      include 'reseau_array.h'
*              real p(ndim),q(ndim),q1(ndim),q2(ndim)
*              real transv(ndim)
      include 'res_array.h'
*              real stdxsi(0:ndim)
      real constante, epais,ep1,ep2,onde,bords0, rf(3)
      integer nm
C
C     General Data input
C
      common /impc/titre
      character * 80 titre
      include 'vector.h'       
      integer m, n
      integer ir, iopt, i, j, in1, ntv(npas)
      real tet, alpha, absorb, qhim(2), qhip(2)
      real a(3), ang(3), rn(3)
      real cosdir, sindir, cosalp, sinalp, tanalp
      real tandir, sin2te, aj, dtet, alanda
      real or(3,3), g(3,3), r(3,3), db(3,3), opt(2,4)
      real som, sop, son, pinit, afin
      real pi, tampon, fou
      integer entree_diff
      parameter (pi = 3.14159)
*
*     OPT defines the minimum and maximum values for the integration
*     step
*
      data opt/0.2,4.,0.1,4.,0.025,4.,0.025,8./
*
      ir = entree_diff(iopt,onde,tet,alpha,absorb,epais,qhim,qhip,a,
     &ang,rn,rf)
      if (ir.ne.0) then
          debut = ir
          return
      endif
*
*     Test on iopt
*
      if (iopt.le.0.or.iopt.gt.4) then
          write(*,*) 'Invalid option: IOPT = ', iopt
          debut = -1
          return
      endif
*
      open (unit=15, file = 'transq.log', iostat =ir,
     &       status='unknown')
      if (ir .ne.0) then
          write(*,*) 'Warning, logfile cannot be opened'
      endif
      write(*, 1000) titre
      write(15, 1000) titre
C       1         2         3         4         5         6         7        8
1000  format('               Program TRANSQ',/,
     &       '               --------------',/,
     &       '                       Traverse topograph',/,
     &       '                       ------------------',//,
     &       '    ',A///)
C
      write (*,1001)  onde,tet,alpha,absorb
     &,qhim,qhip
      write (15,1001)  onde,tet,alpha,absorb
     &,qhim,qhip
1001  format('Diffraction data'/
     &       '----------------'/
     & 'wave length     ',F9.6,' Angstroms'
     &/'Theta           ',F9.3,' Deg.'
     &/'Psi zero        ',F9.3,' Deg.'
     &/'Mu              ',F9.6,' per micron'/
     &'Khi  H minus R',6PF9.4,' 10(-6), Khi  H minus I',F9.4,
     &' 10(-6)'/'Khi  H plus  R',F9.4,' 10(-6), Khi  H plus  I',
     &F9.4,' 10(-6)'/)
*
*     Asymetry for further development only.
*     Not taken into account in deformation equation (see takagi.f)
*
      if(abs(alpha+tet).gt.0.1) then
           write(*,*) 'Warning asymetry not taken into account'
           write(*,*) 'in deformation equation'
           write(15,*) 'Warning asymetry not taken into account'
           write(15,*) 'in deformation equation'
      endif
*
      onde = onde *1.e-04
      tet = tet*pi/180.
      alpha = alpha*pi/180.
      cosdir=cos(alpha+2.*tet)
      sindir=sin(alpha+2.*tet)
      cosalp=cos(alpha)
      sinalp=sin(alpha)
      tanalp=tan(alpha)
      tandir=sindir/cosdir
      sin2te = sin(2.*tet)
      if(cosdir.le.0.) then
           write(*,*) 'Wrong use for the Bragg case. alpha = ',
     &                 alpha 
           debut = -1
           return
      endif
      aj=abs(cmplx(qhim(1),qhim(2))*cmplx(qhip(1),qhip(2)))
*
*     constante pour l'integration
*
      constante = aj*pi*pi/(onde*onde)
      dtet=2.062648e+05*2.*sqrt(aj*cosdir/cosalp)/sin2te
      alanda = onde*sqrt(cosalp*cosdir/aj)
      write(*, 1002) dtet,alanda
      write(15, 1002) dtet,alanda
1002  format('rocking curve half width ',F7.3,' seconds'/
     &       'extinction distance      ',F7.3,' microns'////)
*
      write(*,1003) a,ang
      write(15,1003) a,ang
1003  format('Parameters of the crystal',
     &/,'A =      ', F10.3,' angstroms',
     &/,'B =      ', F10.3,' angstroms',
     &/,'C =      ', F10.3,' angstroms',
     &/,'angles   ',3(F10.3,5X))
      do i = 1,3
         a(i) = a(i)*1.e-04
      enddo
*
      write(*,1004) rn,rf
      write(15,1004) rn,rf
1004  format('Normale to the surface        ',3(5X,F10.3)
     1/'Diffraction vector            ',3(5X,F10.3))
*
*     Computation axes
*
      do i = 1,3
          if( ang(i) .eq. 90. ) then
               ang(i) = 0.
          else
               ang(i) = cos (ang(i) * 3.14159/180.)
          endif
      enddo
*
*     Conversion of normale and reflection vectors in orthogonal
*     direct axes linked to crystal axes.  Unit = 1/micron
*
      call cris(or,a,ang)
      call norma(g,r,a,ang)
      call matri (rf,r)
      call matri(rn,r)
      call matri(rn,or)
      call matri(rf,or)
*
*  Matrix for transformation from crystal axes to macroscopic axes
*             x(i)=db(i,j)*a(j)
*
      som=0.
      son=0.
      sop=0.
      do i=1,3
          som=som+rn(i)*rn(i)
          son=son+rn(i)*rf(i)
      enddo
      do i=1,3
          db(3,i)=rn(i)/sqrt(som)
          db(1,i)=rf(i)-rn(i)*son/som
          sop=sop+db(1,i)*db(1,i)
      enddo
      do  i=1,3
          db(1,i)=db(1,i)/sqrt(sop)
      enddo
      do i=1,3
          m=np(i)
          n=nq(i)
          db(2,i)=db(1,n)*db(3,m)-db(1,m)*db(3,n)
      enddo
*    
*     Reciprocal vector h in macroscopic axes:
*        x along the surface 
*        z perpendicular to surface towards the crystal
*        unit = 1/micron
*
      call matri(rf,db)
*
*     Network of integration for Takagi equations
*     Transformation to reciprocal geometry
*
      tampon = cosalp
      cosalp = cosdir
      cosdir = tampon
      tampon = tanalp
      tanalp = -tandir
      tandir = -tampon
      tampon = sinalp
      sinalp = -sindir
      sindir = -tampon
      rf(2) = -rf(2)
      rf(3) = -rf(3)
*
      afin=opt(2,iopt)
      pinit=opt(1,iopt)
      call reseau(ir,pinit,afin,aj,onde,epais,cosdir,cosalp,
     &tanalp,tandir,sin2te,transv,stdxsi,p,q,q1,q2,ntv,in1)
      if (ir.ne.0) then
         debut = -1
         return
      endif
*
      write(*,1005) epais
      write(15,1005) epais
1005  format('Thickness of crystal:',14x,f8.2,' microns')
      write(*,1006)
      write(15,1006)
1006  format(////'Network of integration'/
     &           '----------------------'/)
      write(*,1007)
      write(15,1007)
1007  format('Distribution of nodes along the base of the triangle')
      j=mod(in1,2)
      j=in1-j
      if(j.ne.0) then  
           write(*,1008) (ntv(i),transv(ntv(i)),i=1,j)
           write(15,1008) (ntv(i),transv(ntv(i)),i=1,j)
1008       format(2(2x,'till point ',I4,4X,F6.3,' microns'))
      endif
      if(j.ne.in1) then
           write(*,1009) ntv(in1),transv(ntv(in1))
           write(15,1009) ntv(in1),transv(ntv(in1))
1009       format(2x,'till point ',I4,4X,F6.3, ' microns')
      endif
*     Constants for calculation
*           - 1 - Constants for absorbtion
*     
      fou=-absorb*sin(alpha+tet)/cos(tet)
*
*           - 2 - intensity along s0 (phi equation)
*
      bords0=exp(-epais*absorb/cosalp)
*
*           - 3 - Constants for integration
*
*     q1 and q2 are functions of q used in the R vector (see takagi)
*     s0x,s0z... are coordinates of nodes along s0 and sh
*     Warning: valid for symetric reflections only
*     For asymetric case use also q3 and q4
*     see notebook IV p.76
*
      ep1 = -epais*tanalp
      ep2 = -epais*tandir
      nm = ntv(in1)
      s0x(0)=0.
      s0z(0)=0.
      shx(0)=0.
      shz(0)=0.
      do i =1,nm 
          q3(i)=q1(i)*rf(3)
          q4(i)=q2(i)*rf(3)
          q1(i)=q1(i)*rf(1)
          q2(i)=q2(i)*rf(1)
          ttrv(i)=exp(stdxsi(i)*fou)*bords0
          s0x(i)=s0x(i-1)-sinalp*p(i)
          s0z(i)=s0z(i-1)+cosalp*p(i)
          shx(i)=shx(i-1)-sindir*q(i)
          shz(i)=shz(i-1)+cosdir*q(i)
      enddo
*
      debut = 0
      return
      end      
*
*
      integer function entree_diff(iopt,onde,tet,alpha,absorb,epais,
     &qhim,qhip,a,ang,rn,rf)

*    *******************************************************************
*    *                                                                 *
*    * titre       comment                                             *
*    * a(3)        crystal parameters   (angstroms)                    *
*    * ang(3)      unit cell angles (degrees)                          *
*    * rn(3)       Normale to surface (Miller indices)                 *
*    * rf(3)       Reflection vector (Reciprocal lattice)              *
*    * onde        wavelength (amgstrom)                               *
*    * tet         Bragg angle                                         *
*    * alpha       asymetry angle   alpha=(n,so) angle from so to      *
*    *             normale ( s0 on left from sh)                       *
*    * qhim(2)     dielectric susceptibility (-g)                      *
*    * qhip(2)                               (+g)                      *
*    * absorb      absorption (per micron)                             *
*    * epais       crystal thickness (microns)                         *
*    * iopt        integration praecision (see below)                  *
*    *                                                                 *
*    *******************************************************************
*
*
*
*              iopt ! afin ! pmean ! pinit ! pmax !
*              -----------------------------------
*              ! 1  !  4.  !  0.8  ! 0.2   ! 1.6  !
*              ! 2  !  4.  !  0.4  ! 0.1   ! 0.8  !
*              ! 3  !  4.  !  0.1  ! 0.025 ! 0.2  !
*              ! 4  !  8.  !  0.2  ! 0.025 ! 1.6  !
*
*
*-----------------------------------------------------------------------
*
      integer ir, iopt
      real onde, epais, a(3), ang(3), rn(3), rf(3)
      real tet, alpha, absorb, qhim(2), qhip(2)
*
      character titre*80
      character filein *40
      common /impa/filein
      common /impc/titre
      integer errcod, iin
      parameter (iin = 10)
      write(*,*) 'Name of diffraction file?'
      read(*,'(a)') filein
      open (unit=iin,file=filein,status = 'old',iostat=errcod)
      if (errcod .ne. 0) then
          write (*,*) 'Error OPEN data file ', filein
          entree_diff= errcod
          return
      endif
      read(iin,1102) titre
1102  format(A)
      read (unit=iin,fmt=*) a
      read (unit=iin,fmt=*) ang
      read (unit=iin,fmt=*) rn 
      read (unit=iin,fmt=*) rf 
      read (unit=iin,fmt=*) onde
      read (unit=iin,fmt=*) tet
      read (unit=iin,fmt=*) alpha
      read (unit=iin,fmt=*) qhim
      read (unit=iin,fmt=*) qhip
      read(unit=iin,fmt=*) absorb
      read (unit=iin,fmt=*) epais 
      read(iin,*) iopt
      close (unit=iin)
*
      entree_diff = 0
      return
      end
C=======================================================================
      SUBROUTINE CRIS(OR,A,ANG)
      REAL OR(3,3),A(3),ANG(3)
      INTEGER I, J
C
C     VALID FOR ORTHOGONAL,HEXAGONAL AND STANDART MONOCLINIC CLASSES
C
      DO 10 I=1,3
      DO 11 J=1,3
11    OR(I,J)=0.
10    OR(I,I)=A(I)
      OR(1,1)=A(1)*SQRT(1.-ANG(2)*ANG(2))
      OR(3,1)=A(1)*ANG(2)
      OR(1,2)=A(2)*ANG(3)
      OR(2,2)=OR(2,2)*SQRT(1.-ANG(3)*ANG(3))
      RETURN
      END
*=======================================================================
      subroutine matri(a,dd)
      real a(3),dd(3,3),c(3)
      integer i, j
C
C   CE PROGRAMME CALCULE LA TRANSFORMATION MATRICIELLE
C    B(I)=DD(I,J)*A(J)
C
      DO 2 I=1,3
      C(I)=0.
      DO 1 J=1,3
1     C(I)=C(I)+DD(I,J)*A(J)
2     CONTINUE
      DO 3  I=1,3
3     A(I)=C(I)
      RETURN
      END
C=======================================================================
      SUBROUTINE NORMA(G,R,A,ANG)
      include 'vector.h'       
*
      REAL G(3,3),R(3,3),A(3),ANG(3)
      INTEGER I, J, K, IA, IB, JA, JB
      REAL DET
C
C   CE PROGRAMME CALCULE LES TENSEURS METRIQUES COVARIANTS ET CONTREVARI
C
C   TENSEUR GIJ DIRECT
C
      DO 1 I=1,3
1     G(I,I)=A(I)*A(I)
      G(1,2)=A(1)*A(2)*ANG(3)
      G(1,3)=A(1)*A(3)*ANG(2)
      G(2,3)=A(2)*A(3)*ANG(1)
      G(2,1)=G(1,2)
      G(3,1)=G(1,3)
      G(3,2)=G(2,3)
C
C   TENSEUR RIJ INVERSE
C
      DET=0.
      DO 2 I=1,3
      J=NP(I)
      K=NQ(I)
2     DET=DET+G(I,1)*G(J,2)*G(K,3)-G(I,1)*G(K,2)*G(J,3)
      DO 3 I=1,3
      IA=NP(I)
      IB=NQ(I)
      DO 3 J=1,3
      JA=NP(J)
      JB=NQ(J)
3     R(I,J)=(G(JA,IA)*G(JB,IB)-G(JB,IA)*G(JA,IB))/DET
      RETURN
      END
*
*=======================================================================
      SUBROUTINE RES(TXSI,NMIN,NMAX,PAS,transv,stdxsi,p,q,ntv,in1)
*
*---  Utilitaire de reseau
*
      include 'reseau.h'              
*
      include 'reseau_array.h'
*              real p(ndim),q(ndim),q1(ndim),q2(ndim)
*              real transv(ndim)
      include 'res_array.h'
*              real stdxsi(0:ndim)
*
      REAL TXSI,PAS
C
      INTEGER IN1,NTV(NPAS),N1,NMIN,NMAX,I
C
      IN1=IN1+1
      N1=INT((TXSI-STDXSI(NMAX))/PAS)
      IF(N1.EQ.0) N1=1
      NMIN=NMAX+1
      NMAX=NMAX+N1
      NTV(IN1)=NMAX
      IF(NMAX.GT.NDIM) then     
           write(*,*) 'too many points in the network of integration'
           write(*,*) 'maximum allowed: ', ndim
           write(*,*) 'requested:       ', nmax
           write(*,*) 'Modify header reseau.h'
           stop 'res'
      endif
      DO 10 I=NMIN,NMAX
C
C---      STDXSI(I) est l'abcisse du i-eme point du reseau sur l'axe xsi
C         et TRANSV(I) est la valeur du i-eme pas du reseau
C
          STDXSI(I)=STDXSI(I-1)+PAS
          TRANSV(I)=PAS
10    CONTINUE
      RETURN
      END
*
*
************************************************************************
*
*
      subroutine reseau(ir,pinit,afin,aj,onde,epais,cosdir,cosalp,
     &tanalp,tandir,sin2te,transv,stdxsi,p,q,q1,q2,ntv,in1)
*
*     Ce sous programme cree le reseau d'integration des equations
*     De Takagi.Il travaille avec le spg utilitaire RES
*
*     aj  = 4/aj**2  dans les calculs theoriques
*
*
      real pi
      parameter (pi=3.14159)
      include 'reseau.h'
*
      include 'reseau_array.h'
*             real p(ndim),q(ndim),q1(ndim),q2(ndim)
*             real transv(ndim)
      include 'res_array.h'
*             real stdxsi(0:ndim)
      real onde,epais,cosdir,cosalp,tanalp,tandir,sin2te
      real pinit,afin,aj,ep0,ep1,ep2,txsi,pas,si,alpha
      real u0(100),dxsi(199)
*
      integer i,j,im,nmax,nmin,i1,im1,in1,ntv(npas),inn2,ir
*
*
************************************************************************
*
*     Calcul approximatif des zeros de J0
*
      aj=(sin2te*onde)**2/(aj*cosalp*cosdir*pi*pi)
      U0(1)=0.
      U0(2)=2.4
      DO 1 I=3,100
          U0(I )=(4.*REAL(I)-5.)*PI/4.
1     CONTINUE
C
C---  Recherche des abscisses correspondantes sur la face de sortie
C
      EP0=TANDIR-TANALP
      IM1=0
      EP1=EPAIS*(TANDIR-TANALP)
      EP1=EP1*EP1
      EP2=-EPAIS*(TANDIR+TANALP)*0.5
C
C---  Jusqu'a la boucle 12 STDXSI n'est utilis{ que comme espace de
*     travail.
C     Ses veritables valeurs sont calculees par le sousprogramme RES
C
10    IM1=IM1+1
      if(im1.gt.100) then      
            write(*,1001)
1001        format('crystal to thick,more than 200 fringes')
            ir = -1 
      endif
*
      U0(IM1)=-U0(IM1)*U0(IM1)*AJ+EP1
      IF(U0(IM1).LT.0.) GOTO 15

      STDXSI(IM1)=EP2+0.5*SQRT(U0(IM1))
      DXSI(IM1)=EP2-0.5*SQRT(U0(IM1))
      GOTO 10
15    IM1=IM1-1
      DO 11 J=1,IM1
          STDXSI(IM1+J)=DXSI(IM1-J+1)
11    CONTINUE
      IM=2*IM1-1
      DO 12 J=1,IM
          DXSI(J)=STDXSI(J)-STDXSI(J+1)
12    CONTINUE
C
C***********************************************************************
C
C     ECHANTILLONAGE DES PAS SUR LA FACE DE SORTIE
C       pas de calcul PAS = PINIT,2*PINIT,4*PINIT ...
C       jusqu'a 2*PMEAN
C     Test sur la variation de DXSI(i) automatique pour choisir
C       ce pas par variation de ALPHA = AINIT,2*ALPHA,2*2ALPHA...
C       jusqu'a ce que 2*PMEAN soit atteint.
C     Echantillonage disymetrique serre vers S0 et plus lache
C     vers SH.
C
C     1)  Premiere moitie pres de S0
C
      NMAX=0
      IN1=0
      STDXSI(0)=0.
      TXSI=0.
      ALPHA=1.
      PAS= PINIT
      SI=1.
      DO 100 I=1,IM1
          TXSI=TXSI+DXSI(I)
          IF(SI*DXSI(I).LT.SI*ALPHA) GOTO 100
          CALL RES(TXSI,NMIN,NMAX,PAS,transv,stdxsi,
     &             p,q,ntv,in1)
          PAS=PAS*2.
          IF(ALPHA.GE.AFIN) GOTO 50

          ALPHA=2.*ALPHA
          GOTO 100
50        SI=-1.
100   CONTINUE
C
C     2)  Deuxieme moitie .pas minimum PMEAN.
C
      IF(DXSI(IM1).LT.AFIN) GOTO 160
      IF(IM1.EQ.1) GOTO 160
      I1=IM1+1
      DO 150 I=I1,IM
          TXSI=TXSI+DXSI(I)
          IF(DXSI(I).GT.1.5*ALPHA) GOTO 150
          CALL RES(TXSI,NMIN,NMAX,PAS,transv,stdxsi,
     &             p,q,ntv,in1)
          PAS=PINIT*AFIN
          GOTO 160
150   CONTINUE
160   TXSI=EPAIS*EP0
      CALL RES(TXSI,NMIN,NMAX,PAS,transv,stdxsi,p,q,ntv,in1)
C
C     ECHANTILLONAGE EGAL A PINIT LE LONG DE SH
C
      INN2=INT(TRANSV(NMAX)/PINIT+0.1)
      IF(INN2.EQ.1) GOTO 180
C
C---  Test pour le cas ou la derniere zone ne contient qu'un point
C
      IF(NMAX-1.EQ.NTV(IN1-1)) GOTO 165
      NTV(IN1)=NMAX-1
      IN1=IN1+1
165   NTV(IN1)=NMAX+INN2-1
      if(ntv(in1).gt.ndim) then      
            write(*,1101) ntv(in1), ndim
1101        format('too many points in the network of integration'/
     &       I4, ' max. allowed ',I4/'Modify header reseau.h')
            ir = -1
            return
      endif
      DO 170 I=1,INN2
          STDXSI(NMAX+I-1)=STDXSI(NMAX+I-1-1)+PINIT
          TRANSV(NMAX+I-1)=PINIT
170   CONTINUE
      NMAX=NMAX+INN2-1
180   CONTINUE
*
*     Calcul des pas obliques P et Q
*     q1, q2 see notebook IV p. 76
*
      do i=1,nmax
          p(nmax-i+1) = transv(i)/(ep0*cosalp)
          q1(i) = transv(i)/ep0*tandir*pi
          q2(i) = -transv(i)/ep0*pi
          q(i) = transv(i)/(ep0*cosdir)
      enddo   
C
C---  Epaisseur du cristal ajustee a la valeur du pas de calcul
C
      EPAIS=STDXSI(NMAX)/EP0
      ir = 0
      RETURN
      END
